/*
    upload64 V1.0, a program to upload Nintendo64 ROM images to the Doctor V64
    This is parlinux.c, the file with the Linux implementations of the low
    level functions. May not work on compilers other than GCC, but who cares.
    Thanks to Fritz Ganter (ganter@ganter.at) and his xmradio for their help.
    Copyright (C) 1997  Andreas Sterbenz (stan@sbox.tu-graz.ac.at)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/

#include <unistd.h>
#include <stdio.h>

void out1byte(unsigned int port, unsigned char c)
{
  __asm__ volatile ("outb %0,%1"
		    ::"a" ((char) c), "d"((unsigned short) port));
}

unsigned char in1byte(unsigned int port)
{
  char _v;
  __asm__ volatile ("inb %1,%0"
		    :"=a" (_v):"d"((unsigned short) port));

  return _v;
}

unsigned int getparport(unsigned int port)
{
  uid_t uid;

  if( port != 0 ) {
    if( ioperm(port, 3, 1) != 0 ) {
      fprintf(stderr, "Could not acquire IO privileges for parallel port at %04x!\n", port);
      fprintf(stderr, "Make sure that this program is SUID root.\n");
      exit(1);
    }
    uid = getuid();
    seteuid(uid);
  }
  return port;
}
