/*
    upload64 V1.0, a program to upload Nintendo64 ROM images to the Doctor V64
    This is parsys.h, the file with the definitions of the system dependent
    functions.
    Copyright (C) 1997  Andreas Sterbenz (stan@sbox.tu-graz.ac.at)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/

#ifndef __PARSYS_H__
#define __PARSYS_H__  1

/* getparport()
 * In:  base port address of the parallel port specified by the user at the
 *      commandline, or 0 if none was specified.
 * Out: the adress of the parallel port to be used or 0 if none could be
 *      found.
 * This function should also take care of whatever system dependent port
 * allocation or initialization procedures which might be required.
 */
unsigned int getparport(unsigned int port);

/* out1byte()
 * Outputs the specified byte on the given port. Usually this function will
 * translate directly into an assembler out instruction.
 */
void out1byte(unsigned int port, unsigned char c);

/* in1byte()
 * Reads a byte from the given port and returns it. Usually this function will
 * translate directly into an assembler in instruction.
 */
unsigned char in1byte(unsigned int port);

#endif
